.nolist
.include "controllers/m32def.inc"
.list
.org 0
rjmp start
.org $20
start:
    LDI r16,low(RAMEND)
    OUT SPL,r16
    LDI r16,high(RAMEND)
    OUT SPH,r16
    
    
;    LDI r16,$ff
;    OUT DDRD,r16
;    LDI r16,0
;  looppp:
;    rjmp looppp
    
    call serial_init
    
    LDI r17,32
   test_loop:
    LDI r16,'U'
    call serial_output
    MOV r16,r17
    call serial_output_hex
    dec r17
    CPI r17,0
    BRNE test_loop    
    
    call serial_output_crlf    
        
    call heap_init
    
    
    LDI r16, low(100)
    LDI r17,high(100)
    call heap_malloc
  m_loop:
    call filesystem_ls
    
    LDI r16,50
    call readline
    call serial_output_crlf
    call filesystem_getpointer
    MOVW r17:r16,Zh:zl
    call serial_output_16bit
    call serial_output_crlf
    icall 
    rjmp m_loop


ramstartstring: 
.db "Heap-First-Free: ",0
ramendstring: 
.db "End of RAM listing",0,0
freistring:
.db " free",0

dump_memory:
    LDI Zl, low(ramstartstring*2)
    LDI Zh,high(ramstartstring*2)
    call serial_output_string_pm
    LDS r16,heap_first_free
    LDS r17,heap_first_free+1
    call serial_output_16bit
    call serial_output_crlf
    LDI xl, low(heap_start);
    LDI xh,high(heap_start);
    
  dump_memory_loop:    
    
    movw r17:r16,Xh:Xl
    call serial_output_16bit
    LDI r16,' '
    call serial_output
  
    LD r18,X+
    LD r19,X+
    movW r17:r16,r19:r18
    call serial_output_16bit
    
    LDI r16,'-'
    call serial_output
    
    LD r18,X+
    LD r19,X+
    movW r17:r16,r19:r18
    CBR r17,$80
    call serial_output_16bit
    
    LDI zl, low(freistring*2);
    LDI zh,high(freistring*2);
    SBRC r19,7
    call serial_output_string_pm
    
    CBR r19,$80
    
    call serial_output_crlf
    
    movw xh:xl,r19:r18
    
    CPI r18,0
    CPC r18,r19
    BRNE dump_memory_loop
    
    LDI Zl, low(ramendstring*2)
    LDI zh,high(ramendstring*2)
    call serial_output_string_pm
    call serial_output_crlf
    
  ret


.include "heap/heap.inc"
.include "serial/serial.inc"
.include "random/random.inc"
.include "strings/strings.inc"
.include "filesystem/filesystem.inc"
.include "filesystem/rootdir.inc"
.include "readline/readline.inc"
.include "filesystem_neu/flash.inc"



    call dump_memory
    
    LDI r16, low(200)
    LDI r17,high(200);
    call heap_malloc
    MOVW r3:r2,Yh:Yl
    LDI r16, low(100)
    LDI r17,high(100);
    call heap_malloc
    MOVW r5:r4,Yh:Yl
    LDI r16, low(50)
    LDI r17,high(50);
    call heap_malloc
    MOVW r7:r6,Yh:Yl
    LDI r16, low(100)
    LDI r17,high(100);
    call heap_malloc
    MOVW r9:r8,Yh:Yl
    
  main_loop:    
    call serial_input
    call random_mixin
    
    call dump_memory
    
    MOVW r17:r16, r3:r2
    call serial_output_16bit
    LDI Zl, low(freestring*2);
    LDI Zh,high(freestring*2);
    call serial_output_string_pm
    MOVW Yh:Yl, r3:r2
    call heap_free
    call serial_output_crlf
    
    MOVW r3:r2,r5:r4
    MOVW r5:r4,r7:r6
    MOVW r7:r6,r9:r8
    
    
    call random_getrandom
    LDI r17,0
    MOVW r19:r18,r17:r16
    call serial_output_16bit    
    LDI Zl, low(mallocstring*2);
    LDI Zh,high(mallocstring*2);
    call serial_output_string_pm
    MOVW r17:r16,r19:r18
    call heap_malloc
    MOVW r17:r16,Yh:Yl
    call serial_output_16bit
    call serial_output_crlf
    MOVW r9:r8,Yh:Yl
    
;    call heap_cleanup
    
    call dump_memory
    rjmp main_loop
    ende: 
        inc r16
    OUT PortD,r16

    rjmp ende

mallocstring:
.db " malloc ",0,0
freestring:
.db " free",0
